#define STDINOUT                (-1)    /* for stdio */

#define HEADER_MESSAGE 		"VDCE"
#define LCVM2DVM		"4000"
#define DVM2LCVM		"5000"
#define DVM2DVM			"5100"

/* Configuration Data(0000) */
#define CIT_Conf 		"0001"
#define CIT_Conf_ACK 		"0002"
#define Task_Activation 	"0003"
#define Task_Deactivation 	"0004"
#define Task_Killing		"0005"
#define Task_Killing_ACK 	"0006"
#define Task_Completion		"0009"
#define	ACT_Feature		"0010"
#define New_Connection		"0011"
#define Received_Data_Size	"0012"

/*Fault data(0100) */
#define VDCE_Init_Error		"0101"
#define VDCE_Send_Error		"0102"
#define VDCE_Recv_Error		"0103"
#define Socket_Open_Error	"0121"
#define Socket_Bind_Error	"0123"
#define Socket_Connect_Error	"0125"
#define Socket_Accept_Error  	"0127"
#define Socket_Read_Error	"0129"
#define Socket_Write_Error	"0131"

#define Memory_Allocation_Error "0141"
#define File_Descriptor_Allocation_Fail		"0142"
#define Gethostname_Error	"0143"

/*Performace Data(0200) */
#define Total_Execution_Time	"0201"
#define Computation_Time	"0203"
#define ACK_Exec_Time		"0301"      /* for LCVM Feb. 12 98 */

/* Time type : 1 (microsec), 2(milisec), 3(sec), 4(minute) 5(hour) */


/* communication type */
#define SOCKET          0
#define MPI             1
#define P4              2
#define DSM             3
#define NCS             4
/* Thread type */
#define NONE            0
#define PTHREAD         1
#define QTHREAD         2
#define CTHREAD         3
/* communication protocol */
#define TCP             0
#define ATM             1
/*QoS*/
#define NOQoS		"QoS"

#define HEADERSIZE 58
#define DUMMYSIZE		10

struct message_header {
char H_name[4];
char message_type[4];
char destination_addr[21];
char source_addr[21];
char length[8] ; /* headersize+datasize */
};

typedef struct message_header VDCE_MSG_HEADER;

struct whoami {
int user_id;
int appl_id;
int task_id;
};
typedef struct whoami WhoAmI;

struct ACT_st {
int user_id;
int appl_id;
int task_id;
int comm_type;
int thread_type;
int comm_protocol;
char QoS[2048];
};
typedef struct ACT_st ACT_format;
